Index: c/src/exec/rtems/ChangeLog
===================================================================
--- c/src/exec/rtems/ChangeLog	(revision ef386359a31777efa7e2ae55a4b4934d1e59583e)
+++ c/src/exec/rtems/ChangeLog	(revision 67ebbcf72df5a6ebf02a075237559e3783878a09)
@@ -1,2 +1,6 @@
+2000-08-30	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	* taskstart.c: Added 1st cut at rtems_task_start_main_style.
+
 2000-08-10	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/exec/rtems/src/taskstart.c
===================================================================
--- c/src/exec/rtems/src/taskstart.c	(revision ef386359a31777efa7e2ae55a4b4934d1e59583e)
+++ c/src/exec/rtems/src/taskstart.c	(revision 67ebbcf72df5a6ebf02a075237559e3783878a09)
@@ -47,8 +47,10 @@
  */
 
-rtems_status_code rtems_task_start(
-  rtems_id         id,
-  rtems_task_entry entry_point,
-  unsigned32       argument
+rtems_status_code rtems_task_start_support(
+  rtems_id            id,
+  rtems_task_entry    entry_point,
+  Thread_Start_types  arg_style,
+  unsigned32          u32_arg,
+  void               *void_arg
 )
 {
@@ -73,5 +75,5 @@
     case OBJECTS_LOCAL:
       if ( _Thread_Start(
-             the_thread, THREAD_START_NUMERIC, entry_point, NULL, argument ) ) {
+             the_thread, arg_style, entry_point, void_arg, u32_arg ) ) {
         _Thread_Enable_dispatch();
         return RTEMS_SUCCESSFUL;
@@ -83,2 +85,33 @@
   return RTEMS_INTERNAL_ERROR;   /* unreached - only to remove warnings */
 }
+
+rtems_status_code rtems_task_start(
+  rtems_id         id,
+  rtems_task_entry entry_point,
+  unsigned32       argument
+)
+{
+  return rtems_task_start_support(
+    id,
+    entry_point,
+    THREAD_START_NUMERIC,
+    argument,
+    NULL
+  );
+}
+
+rtems_status_code rtems_task_start_main_style(
+  rtems_id          id,
+  rtems_task      (*entry_point)(int, char **),
+  int               argc,
+  char            **argv
+)
+{
+  return rtems_task_start_support(
+    id,
+    (rtems_task_entry) entry_point,
+    THREAD_START_BOTH_NUMERIC_FIRST,
+    argc,
+    argv
+  );
+}
Index: cpukit/rtems/ChangeLog
===================================================================
--- cpukit/rtems/ChangeLog	(revision ef386359a31777efa7e2ae55a4b4934d1e59583e)
+++ cpukit/rtems/ChangeLog	(revision 67ebbcf72df5a6ebf02a075237559e3783878a09)
@@ -1,2 +1,6 @@
+2000-08-30	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	* taskstart.c: Added 1st cut at rtems_task_start_main_style.
+
 2000-08-10	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/rtems/src/taskstart.c
===================================================================
--- cpukit/rtems/src/taskstart.c	(revision ef386359a31777efa7e2ae55a4b4934d1e59583e)
+++ cpukit/rtems/src/taskstart.c	(revision 67ebbcf72df5a6ebf02a075237559e3783878a09)
@@ -47,8 +47,10 @@
  */
 
-rtems_status_code rtems_task_start(
-  rtems_id         id,
-  rtems_task_entry entry_point,
-  unsigned32       argument
+rtems_status_code rtems_task_start_support(
+  rtems_id            id,
+  rtems_task_entry    entry_point,
+  Thread_Start_types  arg_style,
+  unsigned32          u32_arg,
+  void               *void_arg
 )
 {
@@ -73,5 +75,5 @@
     case OBJECTS_LOCAL:
       if ( _Thread_Start(
-             the_thread, THREAD_START_NUMERIC, entry_point, NULL, argument ) ) {
+             the_thread, arg_style, entry_point, void_arg, u32_arg ) ) {
         _Thread_Enable_dispatch();
         return RTEMS_SUCCESSFUL;
@@ -83,2 +85,33 @@
   return RTEMS_INTERNAL_ERROR;   /* unreached - only to remove warnings */
 }
+
+rtems_status_code rtems_task_start(
+  rtems_id         id,
+  rtems_task_entry entry_point,
+  unsigned32       argument
+)
+{
+  return rtems_task_start_support(
+    id,
+    entry_point,
+    THREAD_START_NUMERIC,
+    argument,
+    NULL
+  );
+}
+
+rtems_status_code rtems_task_start_main_style(
+  rtems_id          id,
+  rtems_task      (*entry_point)(int, char **),
+  int               argc,
+  char            **argv
+)
+{
+  return rtems_task_start_support(
+    id,
+    (rtems_task_entry) entry_point,
+    THREAD_START_BOTH_NUMERIC_FIRST,
+    argc,
+    argv
+  );
+}
